org.eclipse.viatra.integration.uml.derivedfeatures

## Class RedefinableElementRedefinedElementMatcher

- java.lang.Object
- - org.eclipse.viatra.query.runtime.internal.apiimpl.QueryResultWrapper
  - - org.eclipse.viatra.query.runtime.api.impl.BaseMatcher<RedefinableElementRedefinedElementMatch>
    - - org.eclipse.viatra.integration.uml.derivedfeatures.RedefinableElementRedefinedElementMatcher

- All Implemented Interfaces:
    ViatraQueryMatcher<RedefinableElementRedefinedElementMatch>

      public class RedefinableElementRedefinedElementMatcher
      extends BaseMatcher<RedefinableElementRedefinedElementMatch>

  Generated pattern matcher API of the org.eclipse.viatra.integration.uml.derivedfeatures.redefinableElementRedefinedElement pattern, providing pattern-specific query methods.

  Use the pattern matcher on a given model via `on(ViatraQueryEngine)`, e.g. in conjunction with `ViatraQueryEngine#on(Notifier)`.

  Matches of the pattern will be represented as `RedefinableElementRedefinedElementMatch`.

  Original source: ``

        @Surrogate(feature = "redefinedElement")
        @QueryExplorer(checked = false)
       pattern redefinableElementRedefinedElement(source: RedefinableElement, target: RedefinableElement)
       { ActivityEdge.redefinedEdge(source, target); } or
       { ActivityNode.redefinedNode(source, target); } or
       { Classifier.redefinedClassifier(source, target); } or
       { Connector.redefinedConnector(source, target); } or
       { Operation.redefinedOperation(source, target); } or
       { Property.redefinedProperty(source, target); } or
       { RedefinableTemplateSignature.extendedSignature(source, target); } or
       { Region.extendedRegion(source, target); } or
       { State.redefinedState(source, target); } or
       { Transition.redefinedTransition(source, target); }

  See Also:
    `RedefinableElementRedefinedElementMatch`, `RedefinableElementRedefinedElementProcessor`, `RedefinableElementRedefinedElementQuerySpecification`

- - ### Field Summary

    - ### Fields inherited from class org.eclipse.viatra.query.runtime.api.impl.BaseMatcher

      `engine, querySpecification`

    - ### Fields inherited from class org.eclipse.viatra.query.runtime.internal.apiimpl.QueryResultWrapper

      `backend`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected RedefinableElementRedefinedElementMatch` | `arrayToMatch(java.lang.Object[] match)` Converts the array representation of a pattern match to an immutable Match object.
    `protected RedefinableElementRedefinedElementMatch` | `arrayToMatchMutable(java.lang.Object[] match)` Converts the array representation of a pattern match to a mutable Match object.
    `int` | `countMatches(org.eclipse.uml2.uml.RedefinableElement pSource, org.eclipse.uml2.uml.RedefinableElement pTarget)` Returns the number of all matches of the pattern that conform to the given fixed values of some parameters.
    `static RedefinableElementRedefinedElementMatcher` | `create()`
    `void` | `forEachMatch(org.eclipse.uml2.uml.RedefinableElement pSource, org.eclipse.uml2.uml.RedefinableElement pTarget, IMatchProcessor<? super RedefinableElementRedefinedElementMatch> processor)` Executes the given processor on each match of the pattern that conforms to the given fixed values of some parameters.
    `boolean` | `forOneArbitraryMatch(org.eclipse.uml2.uml.RedefinableElement pSource, org.eclipse.uml2.uml.RedefinableElement pTarget, IMatchProcessor<? super RedefinableElementRedefinedElementMatch> processor)` Executes the given processor on an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters.
    `java.util.Collection<RedefinableElementRedefinedElementMatch>` | `getAllMatches(org.eclipse.uml2.uml.RedefinableElement pSource, org.eclipse.uml2.uml.RedefinableElement pTarget)` Returns the set of all matches of the pattern that conform to the given fixed values of some parameters.
    `java.util.Set<org.eclipse.uml2.uml.RedefinableElement>` | `getAllValuesOfsource()` Retrieve the set of values that occur in matches for source.
    `java.util.Set<org.eclipse.uml2.uml.RedefinableElement>` | `getAllValuesOfsource(org.eclipse.uml2.uml.RedefinableElement pTarget)` Retrieve the set of values that occur in matches for source.
    `java.util.Set<org.eclipse.uml2.uml.RedefinableElement>` | `getAllValuesOfsource(RedefinableElementRedefinedElementMatch partialMatch)` Retrieve the set of values that occur in matches for source.
    `java.util.Set<org.eclipse.uml2.uml.RedefinableElement>` | `getAllValuesOftarget()` Retrieve the set of values that occur in matches for target.
    `java.util.Set<org.eclipse.uml2.uml.RedefinableElement>` | `getAllValuesOftarget(org.eclipse.uml2.uml.RedefinableElement pSource)` Retrieve the set of values that occur in matches for target.
    `java.util.Set<org.eclipse.uml2.uml.RedefinableElement>` | `getAllValuesOftarget(RedefinableElementRedefinedElementMatch partialMatch)` Retrieve the set of values that occur in matches for target.
    `RedefinableElementRedefinedElementMatch` | `getOneArbitraryMatch(org.eclipse.uml2.uml.RedefinableElement pSource, org.eclipse.uml2.uml.RedefinableElement pTarget)` Returns an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters.
    `boolean` | `hasMatch(org.eclipse.uml2.uml.RedefinableElement pSource, org.eclipse.uml2.uml.RedefinableElement pTarget)` Indicates whether the given combination of specified pattern parameters constitute a valid pattern match, under any possible substitution of the unspecified parameters (if any).
    `RedefinableElementRedefinedElementMatch` | `newMatch(org.eclipse.uml2.uml.RedefinableElement pSource, org.eclipse.uml2.uml.RedefinableElement pTarget)` Returns a new (partial) match.
    `static RedefinableElementRedefinedElementMatcher` | `on(ViatraQueryEngine engine)` Initializes the pattern matcher within an existing VIATRA Query engine.
    `static IQuerySpecification<RedefinableElementRedefinedElementMatcher>` | `querySpecification()`
    `protected java.util.Set<org.eclipse.uml2.uml.RedefinableElement>` | `rawAccumulateAllValuesOfsource(java.lang.Object[] parameters)` Retrieve the set of values that occur in matches for source.
    `protected java.util.Set<org.eclipse.uml2.uml.RedefinableElement>` | `rawAccumulateAllValuesOftarget(java.lang.Object[] parameters)` Retrieve the set of values that occur in matches for target.
    `protected RedefinableElementRedefinedElementMatch` | `tupleToMatch(Tuple t)`

    - ### Methods inherited from class org.eclipse.viatra.query.runtime.api.impl.BaseMatcher

      `countMatches, countMatches, emptyArray, forEachMatch, forEachMatch, forOneArbitraryMatch, forOneArbitraryMatch, getAllMatches, getAllMatches, getAllValues, getAllValues, getCapabilities, getEngine, getOneArbitraryMatch, getOneArbitraryMatch, getParameterNames, getPatternName, getPositionOfParameter, getSpecification, hasMatch, matchToArray, newEmptyMatch, newMatch, rawAccumulateAllValues, rawCountMatches, rawForEachMatch, rawForOneArbitraryMatch, rawGetAllMatches, rawGetAllValues, rawGetOneArbitraryMatch, rawHasMatch, setBackend`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### on

          public static RedefinableElementRedefinedElementMatcher on(ViatraQueryEngine engine)
                                                              throws ViatraQueryException

      Initializes the pattern matcher within an existing VIATRA Query engine. If the pattern matcher is already constructed in the engine, only a light-weight reference is returned. The match set will be incrementally refreshed upon updates.
      Parameters:
        `engine` - the existing VIATRA Query engine in which this matcher will be created.
      Throws:
        `ViatraQueryException` - if an error occurs during pattern matcher creation

    - #### create

          public static RedefinableElementRedefinedElementMatcher create()
                                                                  throws ViatraQueryException

      Returns:
        an initialized matcher
      Throws:
        `ViatraQueryException` - if an error occurs during pattern matcher creation
      No Reference:
        This method is for internal matcher initialization by the framework, do not call it manually.

    - #### getAllMatches

          public java.util.Collection<RedefinableElementRedefinedElementMatch> getAllMatches(org.eclipse.uml2.uml.RedefinableElement pSource,
                                                                                             org.eclipse.uml2.uml.RedefinableElement pTarget)

      Returns the set of all matches of the pattern that conform to the given fixed values of some parameters.
      Parameters:
        `pSource` - the fixed value of pattern parameter source, or null if not bound.
        `pTarget` - the fixed value of pattern parameter target, or null if not bound.
      Returns:
        matches represented as a RedefinableElementRedefinedElementMatch object.

    - #### getOneArbitraryMatch

          public RedefinableElementRedefinedElementMatch getOneArbitraryMatch(org.eclipse.uml2.uml.RedefinableElement pSource,
                                                                              org.eclipse.uml2.uml.RedefinableElement pTarget)

      Returns an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters. Neither determinism nor randomness of selection is guaranteed.
      Parameters:
        `pSource` - the fixed value of pattern parameter source, or null if not bound.
        `pTarget` - the fixed value of pattern parameter target, or null if not bound.
      Returns:
        a match represented as a RedefinableElementRedefinedElementMatch object, or null if no match is found.

    - #### hasMatch

          public boolean hasMatch(org.eclipse.uml2.uml.RedefinableElement pSource,
                                  org.eclipse.uml2.uml.RedefinableElement pTarget)

      Indicates whether the given combination of specified pattern parameters constitute a valid pattern match, under any possible substitution of the unspecified parameters (if any).
      Parameters:
        `pSource` - the fixed value of pattern parameter source, or null if not bound.
        `pTarget` - the fixed value of pattern parameter target, or null if not bound.
      Returns:
        true if the input is a valid (partial) match of the pattern.

    - #### countMatches

          public int countMatches(org.eclipse.uml2.uml.RedefinableElement pSource,
                                  org.eclipse.uml2.uml.RedefinableElement pTarget)

      Returns the number of all matches of the pattern that conform to the given fixed values of some parameters.
      Parameters:
        `pSource` - the fixed value of pattern parameter source, or null if not bound.
        `pTarget` - the fixed value of pattern parameter target, or null if not bound.
      Returns:
        the number of pattern matches found.

    - #### forEachMatch

          public void forEachMatch(org.eclipse.uml2.uml.RedefinableElement pSource,
                                   org.eclipse.uml2.uml.RedefinableElement pTarget,
                                   IMatchProcessor<? super RedefinableElementRedefinedElementMatch> processor)

      Executes the given processor on each match of the pattern that conforms to the given fixed values of some parameters.
      Parameters:
        `pSource` - the fixed value of pattern parameter source, or null if not bound.
        `pTarget` - the fixed value of pattern parameter target, or null if not bound.
        `processor` - the action that will process each pattern match.

    - #### forOneArbitraryMatch

          public boolean forOneArbitraryMatch(org.eclipse.uml2.uml.RedefinableElement pSource,
                                              org.eclipse.uml2.uml.RedefinableElement pTarget,
                                              IMatchProcessor<? super RedefinableElementRedefinedElementMatch> processor)

      Executes the given processor on an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters. Neither determinism nor randomness of selection is guaranteed.
      Parameters:
        `pSource` - the fixed value of pattern parameter source, or null if not bound.
        `pTarget` - the fixed value of pattern parameter target, or null if not bound.
        `processor` - the action that will process the selected match.
      Returns:
        true if the pattern has at least one match with the given parameter values, false if the processor was not invoked

    - #### newMatch

          public RedefinableElementRedefinedElementMatch newMatch(org.eclipse.uml2.uml.RedefinableElement pSource,
                                                                  org.eclipse.uml2.uml.RedefinableElement pTarget)

      Returns a new (partial) match. This can be used e.g. to call the matcher with a partial match.

      The returned match will be immutable. Use `BaseMatcher.newEmptyMatch()` to obtain a mutable match object.

      Parameters:
        `pSource` - the fixed value of pattern parameter source, or null if not bound.
        `pTarget` - the fixed value of pattern parameter target, or null if not bound.
      Returns:
        the (partial) match object.

    - #### rawAccumulateAllValuesOfsource

          protected java.util.Set<org.eclipse.uml2.uml.RedefinableElement> rawAccumulateAllValuesOfsource(java.lang.Object[] parameters)

      Retrieve the set of values that occur in matches for source.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOfsource

          public java.util.Set<org.eclipse.uml2.uml.RedefinableElement> getAllValuesOfsource()

      Retrieve the set of values that occur in matches for source.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOfsource

          public java.util.Set<org.eclipse.uml2.uml.RedefinableElement> getAllValuesOfsource(RedefinableElementRedefinedElementMatch partialMatch)

      Retrieve the set of values that occur in matches for source.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOfsource

          public java.util.Set<org.eclipse.uml2.uml.RedefinableElement> getAllValuesOfsource(org.eclipse.uml2.uml.RedefinableElement pTarget)

      Retrieve the set of values that occur in matches for source.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### rawAccumulateAllValuesOftarget

          protected java.util.Set<org.eclipse.uml2.uml.RedefinableElement> rawAccumulateAllValuesOftarget(java.lang.Object[] parameters)

      Retrieve the set of values that occur in matches for target.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOftarget

          public java.util.Set<org.eclipse.uml2.uml.RedefinableElement> getAllValuesOftarget()

      Retrieve the set of values that occur in matches for target.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOftarget

          public java.util.Set<org.eclipse.uml2.uml.RedefinableElement> getAllValuesOftarget(RedefinableElementRedefinedElementMatch partialMatch)

      Retrieve the set of values that occur in matches for target.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOftarget

          public java.util.Set<org.eclipse.uml2.uml.RedefinableElement> getAllValuesOftarget(org.eclipse.uml2.uml.RedefinableElement pSource)

      Retrieve the set of values that occur in matches for target.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### tupleToMatch

          protected RedefinableElementRedefinedElementMatch tupleToMatch(Tuple t)

      Specified by:
        `tupleToMatch` in class `BaseMatcher<RedefinableElementRedefinedElementMatch>`

    - #### arrayToMatch

          protected RedefinableElementRedefinedElementMatch arrayToMatch(java.lang.Object[] match)

      Description copied from class: `BaseMatcher`
      Converts the array representation of a pattern match to an immutable Match object.
      Specified by:
        `arrayToMatch` in class `BaseMatcher<RedefinableElementRedefinedElementMatch>`

    - #### arrayToMatchMutable

          protected RedefinableElementRedefinedElementMatch arrayToMatchMutable(java.lang.Object[] match)

      Description copied from class: `BaseMatcher`
      Converts the array representation of a pattern match to a mutable Match object.
      Specified by:
        `arrayToMatchMutable` in class `BaseMatcher<RedefinableElementRedefinedElementMatch>`

    - #### querySpecification

          public static IQuerySpecification<RedefinableElementRedefinedElementMatcher> querySpecification()
                                                                                                   throws ViatraQueryException

      Returns:
        the singleton instance of the query specification of this pattern
      Throws:
        `ViatraQueryException` - if the pattern definition could not be loaded